% Closed phase analysis

clear
close all
clc

path('..\..\voicebox',path)

nlpc =  14;

% Load workspace from previous exercise
load ex8p3

%% Select voiced segment in utterance
ix = 30200:31200;
x    = x(ix);
egg  = egg(ix);
degg = degg(ix);
% soundsc(x,fs);

% Find GCis within the voiced segment
ix1 = find(gci_e>=ix(1) & gci_e<=ix(end) & goi_e>=ix(1) & goi_e<=ix(end) );
gci_e = gci_e(ix1)-ix(1)+1;
goi_e = goi_e(ix1)-ix(1)+1;

ix1 = find(gci_x>=ix(1) & gci_x<=ix(end) & goi_x>=ix(1) & goi_x<=ix(end) );
gci_x = gci_x(ix1)-ix(1)+1;
goi_x = goi_x(ix1)-ix(1)+1;

%% Plot segment
x    = (x-mean(x))/std(x);
egg  = (egg-mean(egg))/std(egg);
degg = (degg)/std(degg);

hold on
plot(x, 'b'); 
plot(egg, 'r'); 
plot(degg, 'g'); 

plot([gci_x; goi_x], [1 1], 'b', 'LineWidth', 2);
plot([gci_e; goi_e], [-1 -1], 'g', 'LineWidth', 2);
axis tight

%%  Compute LPC model on closed sections  
% (need to use covariance method for closed phase analysis)

r = 0*x;
gci = gci_e;
goi = goi_e;

for f = 1:length(gci)-1
  s = x(gci(f):goi(f));
  [a e] = lpccovar(s,nlpc);

  % Compute residual for the entire pitch period
  s = x(gci(f):gci(f+1));
  r(gci(f):gci(f+1)) = filter(a,1,s);
end

% Compute LPC model on the entire pitch period
% r1 = 0*x;
% for f = 1:length(gci)-1
%   s = x(gci(f):gci(f+1));
%   [a e] = lpccovar(s,nlpc);
% 
%   s = x(gci(f):gci(f+1));
%   r1(gci(f):gci(f+1)) = filter(a,1,s);
% end
r1 = filter(lpc(x.*hamming(length(x)),nlpc),1,x);

figure
subplot(211); plot(r, 'b'); axis tight
subplot(212); plot(r1, 'r'); axis tight


